mod Ex02c

incl Mtex

incl Mtexrc

incl Mtexseq

incl Mauxc

loc rem 
  \para \bf  2. CVICENIE Z PREDMETU 1-INF-450 LOGIKA PRE INFORMATIKOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end stvrtok 28.9.2006 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-450-lpi/0607zs/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane primitivne 
  rekurzivnym funkciam (zakladny vyvoj, konecne postupnosti). Zadanie sa sklada 
  z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 0 
   \item \para Pocet bodov za premiove ulohy v tomto subore:: 2 
  \end
  \para Prenos: 
  \verbatim 
  ftp://barbie.nw.fmph.uniba.sk/data/vyuka/inf/cl/M-INBP-004/prenos/ex/ex<ord>/<user>/ex*.cl 
  \end
  \para Odovzdat do 3.10.2006 (utorok) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Part. Arithmetization of finite sequences of numbers.  \end 

rem 
  \para \bf  Exercise.  \end Show that the predicate \ft Prime(x) \end holding 
  of prime numbers is primitive recursive. 

pred Prime 
  Prime(x) <-> Poo

rem 
  \para \bf  [CL] Characteristic function of the prime predicate.  \end 

appldisp/1 Tex_f1_char_primef
  Prefix(100,2,Subsup(Id(1,'Prime',0),75,Op('*',0),None),Arg(0))

fun Primef 'Tex_f1_char_primef'
  Primef(x) = 1 <- Prime(x)
  Primef(x) = 0 <- ~Prime(x)

rem 
  \para \bf  Exercise.  \end \header* fun Np 'Tex_f1_seq_np' \end Show that the 
  function \ft Np(x) \end counting the number of primes \ft p <= x \end is 
  primitive recursive. 

fun Np 'Tex_f1_seq_np'
  Np(x) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun Ep 'Tex_f1_seq_ep' \end Show that the 
  function \ft Ep(i) \end yielding the (i+1)-st prime number, i.e. 
  \eq* 
    Ep(0) = 2
  \end
  \eq* 
    Ep(1) = 3
  \end
  \eq* 
    Ep(2) = 5
  \end
  \eq* 
    Ep(3) = 7
  \end
  \eq* 
    Ep(4) = 11
  \end
  \para is primitive recursive. 

fun Ep 'Tex_f1_seq_ep'
  Ep(i) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/2 Ex 'Tex_f2_seq_ex' \end Show that 
  the function \ft Ex(i,x) \end yielding the exponent of \ft Ep(i) \end in the 
  prime factorization of the number \ft x != 0 \end is primitive recursive. We 
  set \ft Ex(i,0) = 0 \end. 

fun/2 Ex 'Tex_f2_seq_ex'
  Ex(i,x) = Foo

rem 
  \para \bf  Coding of finite sequences of numbers.  \end Examples: 
  \items 
   \item \para the empty sequence is coded by the number \ft 1 \end, 
   \item \para the non-empty sequence \ft 10,11,12,13,14 \end is coded by the 
         number 
         \eq* 
           Exp(2,10+1)*Exp(3,11+1)*Exp(5,12+1)*Exp(7,13+1)*Exp(11,14+1)
         \end
  \end

rem 
  \para \bf  Exercise.  \end \it  [Premiova uloha (1 bod)]  \end 
  \header* pred Seq 'Tex_p1_seq_seq' \end Show that the predicate 
  \ft Seq(x) \end holding of the codes of finite sequences of numbers is 
  primitive recursive. 

pred Seq 'Tex_p1_seq_seq'
  Seq(x) <-> Poo

rem 
  \para \bf  Exercise.  \end \it  [Premiova uloha (1 bod)]  \end 
  \header* fun Lh 'Tex_f1_seq_lh' \end Show that the function \ft Lh(x) \end 
  yielding the length of a finite sequence coded by \ft x \end is primitive 
  recursive. 

fun Lh 'Tex_f1_seq_lh'
  Lh(x) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/2 Sub 'Tex_f2_ln_sub' \end Show that 
  the function \ft Sub(x,i) \end yielding the (i+1)-st element of a finite 
  sequence coded by \ft x \end is primitive recursive. 

fun/2 Sub 'Tex_f2_ln_sub'
  Sub(x,i) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

loc fun/2 Ln2code2 
  Ln2code2(i,0) = 1
  Ln2code2(i,v,w) = Exp(Ep(i),v+1)*Ln2code2(i+1,w)

loc fun Ln2code 
  Ln2code(x) = Ln2code2(0,x)

